# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from cobo_waas2.models.settle_request_status import SettleRequestStatus
from cobo_waas2.models.settlement_detail import SettlementDetail
from typing import Optional, Set
from typing_extensions import Self


class Settlement(BaseModel):
    """
    Settlement
    """  # noqa: E501
    settlement_request_id: StrictStr = Field(description="Internal system-generated identifier with a human-readable format. Used primarily for internal operations and logging.")
    request_id: StrictStr = Field(description="Client-provided external identifier.")
    status: SettleRequestStatus
    settlements: List[SettlementDetail]
    __properties: ClassVar[List[str]] = ["settlement_request_id", "request_id", "status", "settlements"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Settlement from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in settlements (list)
        _items = []
        if self.settlements:
            for _item in self.settlements:
                if _item:
                    _items.append(_item.to_dict())
            _dict['settlements'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Settlement from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "settlement_request_id": obj.get("settlement_request_id"),
            "request_id": obj.get("request_id"),
            "status": obj.get("status"),
            "settlements": [SettlementDetail.from_dict(_item) for _item in obj["settlements"]] if obj.get("settlements") is not None else None
        })
        return _obj


