# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from cobo_waas2.models.activity_type import ActivityType
from cobo_waas2.models.transaction_extra_type import TransactionExtraType
from typing import Optional, Set
from typing_extensions import Self


class TransactionBabylonTxParameters(BaseModel):
    """
    The Babylon transaction parameters.
    """  # noqa: E501
    extra_type: TransactionExtraType
    stake_amount: Optional[StrictStr] = Field(default=None, description="The origin staking amount.")
    finality_provider_public_key: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="The public key of the finality provider.")
    stake_block_time: Optional[StrictInt] = Field(default=None, description="The number of blocks that need to be processed before the locked tokens are unlocked and become accessible.")
    param_version: Optional[StrictInt] = Field(default=None, description="The version of babylon global parameters.")
    withdraw_from_type: Optional[ActivityType] = None
    slash_from_type: Optional[ActivityType] = None
    __properties: ClassVar[List[str]] = ["extra_type", "stake_amount", "finality_provider_public_key", "stake_block_time", "param_version", "withdraw_from_type", "slash_from_type"]

    @field_validator('finality_provider_public_key')
    def finality_provider_public_key_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[0-9a-fA-F]{64}$", value):
            raise ValueError(r"must validate the regular expression /^[0-9a-fA-F]{64}$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TransactionBabylonTxParameters from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TransactionBabylonTxParameters from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "extra_type": obj.get("extra_type"),
            "stake_amount": obj.get("stake_amount"),
            "finality_provider_public_key": obj.get("finality_provider_public_key"),
            "stake_block_time": obj.get("stake_block_time"),
            "param_version": obj.get("param_version"),
            "withdraw_from_type": obj.get("withdraw_from_type"),
            "slash_from_type": obj.get("slash_from_type")
        })
        return _obj


