# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class TransactionCoboCategory(str, Enum):
    """
    The transaction category defined by Cobo. Possible values include:    - `AutoSweep`: An auto-sweep transaction.   - `AutoFueling`: A transaction where Fee Station pays transaction fees to an address within your MPC Wallets.   - `AutoFuelingRefund`: A refund for an auto-fueling transaction.   - `SafeTxMessage`: A message signing transaction initiated by an MPC wallet to authorize a Smart Contract Wallet (Safe\\{Wallet\\}) transaction.   - `BillPayment`: A transaction to pay Cobo bills through Fee Station.   - `BillRefund`: A refund for a previously made bill payment.   - `CommissionFeeCharge`: A transaction to charge commission fees via Fee Station.   - `CommissionFeeRefund`: A refund of previously charged commission fees. 
    """

    """
    allowed enum values
    """
    AUTOSWEEP = 'AutoSweep'
    AUTOFUELING = 'AutoFueling'
    AUTOFUELINGREFUND = 'AutoFuelingRefund'
    SAFETXMESSAGE = 'SafeTxMessage'
    BILLPAYMENT = 'BillPayment'
    BILLREFUND = 'BillRefund'
    COMMISSIONFEECHARGE = 'CommissionFeeCharge'
    COMMISSIONFEEREFUND = 'CommissionFeeRefund'

    UNKNOWN = None

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of TransactionCoboCategory from a JSON string"""
        return cls(json.loads(json_str))

    @classmethod
    def _missing_(cls, value):
        return cls.UNKNOWN


