# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from cobo_waas2.models.transaction_babylon_business_info import TransactionBabylonBusinessInfo
from cobo_waas2.models.transaction_babylon_tx_parameters import TransactionBabylonTxParameters
from cobo_waas2.models.transaction_core_stake_info import TransactionCoreStakeInfo
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

TRANSACTIONEXTRA_ONE_OF_SCHEMAS = ["TransactionBabylonBusinessInfo", "TransactionBabylonTxParameters", "TransactionCoreStakeInfo"]

class TransactionExtra(BaseModel):
    """
    TransactionExtra
    """
    # data type: TransactionBabylonBusinessInfo
    oneof_schema_1_validator: Optional[TransactionBabylonBusinessInfo] = None
    # data type: TransactionBabylonTxParameters
    oneof_schema_2_validator: Optional[TransactionBabylonTxParameters] = None
    # data type: TransactionCoreStakeInfo
    oneof_schema_3_validator: Optional[TransactionCoreStakeInfo] = None
    actual_instance: Optional[Union[TransactionBabylonBusinessInfo, TransactionBabylonTxParameters, TransactionCoreStakeInfo]] = None
    one_of_schemas: Set[str] = { "TransactionBabylonBusinessInfo", "TransactionBabylonTxParameters", "TransactionCoreStakeInfo" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = TransactionExtra.model_construct()
        error_messages = []
        match = 0
        # validate data type: TransactionBabylonBusinessInfo
        if not isinstance(v, TransactionBabylonBusinessInfo):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TransactionBabylonBusinessInfo`")
        else:
            match += 1
        # validate data type: TransactionBabylonTxParameters
        if not isinstance(v, TransactionBabylonTxParameters):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TransactionBabylonTxParameters`")
        else:
            match += 1
        # validate data type: TransactionCoreStakeInfo
        if not isinstance(v, TransactionCoreStakeInfo):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TransactionCoreStakeInfo`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in TransactionExtra with oneOf schemas: TransactionBabylonBusinessInfo, TransactionBabylonTxParameters, TransactionCoreStakeInfo. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in TransactionExtra with oneOf schemas: TransactionBabylonBusinessInfo, TransactionBabylonTxParameters, TransactionCoreStakeInfo. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("extra_type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `extra_type` in the input.")

        # check if data type is `TransactionBabylonBusinessInfo`
        if _data_type == "BabylonBusinessInfo":
            instance.actual_instance = TransactionBabylonBusinessInfo.from_json(json_str)
            return instance

        # check if data type is `TransactionBabylonTxParameters`
        if _data_type == "BabylonTxParameters":
            instance.actual_instance = TransactionBabylonTxParameters.from_json(json_str)
            return instance

        # check if data type is `TransactionCoreStakeInfo`
        if _data_type == "CoreStakeInfo":
            instance.actual_instance = TransactionCoreStakeInfo.from_json(json_str)
            return instance

        # check if data type is `TransactionBabylonBusinessInfo`
        if _data_type == "TransactionBabylonBusinessInfo":
            instance.actual_instance = TransactionBabylonBusinessInfo.from_json(json_str)
            return instance

        # check if data type is `TransactionBabylonTxParameters`
        if _data_type == "TransactionBabylonTxParameters":
            instance.actual_instance = TransactionBabylonTxParameters.from_json(json_str)
            return instance

        # check if data type is `TransactionCoreStakeInfo`
        if _data_type == "TransactionCoreStakeInfo":
            instance.actual_instance = TransactionCoreStakeInfo.from_json(json_str)
            return instance

        return instance
        # deserialize data into TransactionBabylonBusinessInfo
        try:
            instance.actual_instance = TransactionBabylonBusinessInfo.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TransactionBabylonTxParameters
        try:
            instance.actual_instance = TransactionBabylonTxParameters.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TransactionCoreStakeInfo
        try:
            instance.actual_instance = TransactionCoreStakeInfo.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into TransactionExtra with oneOf schemas: TransactionBabylonBusinessInfo, TransactionBabylonTxParameters, TransactionCoreStakeInfo. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            return instance
            # raise ValueError("No match found when deserializing the JSON string into TransactionExtra with oneOf schemas: TransactionBabylonBusinessInfo, TransactionBabylonTxParameters, TransactionCoreStakeInfo. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], TransactionBabylonBusinessInfo, TransactionBabylonTxParameters, TransactionCoreStakeInfo]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


